From a489c94fdb54ab8ce83707b9313be2ae06ef06da Mon Sep 17 00:00:00 2001
From: Sieu Mun Tang <sieu.mun.tang@intel.com>
Date: Fri, 20 Oct 2023 18:38:14 +0800
Subject: [PATCH] plat: intel: soc: agilex5: enable NAND boot

This patch enables NAND front door load/boot with Simics.

Signed-off-by: Girisha Dengi <girisha.dengi@intel.com>
Signed-off-by: Sieu Mun Tang <sieu.mun.tang@intel.com>
---
 plat/intel/soc/agilex5/bl2_plat_setup.c           | 9 +++++----
 plat/intel/soc/agilex5/include/socfpga_plat_def.h | 2 +-
 plat/intel/soc/common/drivers/combophy/combophy.h | 4 ++--
 plat/intel/soc/common/drivers/sdmmc/sdmmc.h       | 2 +-
 4 files changed, 9 insertions(+), 8 deletions(-)

diff --git a/plat/intel/soc/agilex5/bl2_plat_setup.c b/plat/intel/soc/agilex5/bl2_plat_setup.c
index c74d799c2..4bd9bce5c 100644
--- a/plat/intel/soc/agilex5/bl2_plat_setup.c
+++ b/plat/intel/soc/agilex5/bl2_plat_setup.c
@@ -12,6 +12,7 @@
 #include <common/debug.h>
 #include <common/desc_image_load.h>
 #include <drivers/cadence/cdns_sdmmc.h>
+#include <drivers/cadence/cdns_nand.h>
 #include <drivers/generic_delay_timer.h>
 #include <drivers/synopsys/dw_mmc.h>
 #include <drivers/ti/uart/uart_16550.h>
@@ -88,10 +89,10 @@ void bl2_el3_early_platform_setup(u_register_t x0, u_register_t x1,
 	// TODO: Temp workaround to ungate testing
 	// mmio_write_32(L2_RESET_DONE_REG, PLAT_L2_RESET_REQ);
 
-	if (!intel_mailbox_is_fpga_not_ready()) {
-		socfpga_bridges_enable(SOC2FPGA_MASK | LWHPS2FPGA_MASK |
-					FPGA2SOC_MASK | F2SDRAM0_MASK);
-	}
+	// if (!intel_mailbox_is_fpga_not_ready()) {
+		// socfpga_bridges_enable(SOC2FPGA_MASK | LWHPS2FPGA_MASK |
+					// FPGA2SOC_MASK | F2SDRAM0_MASK);
+	// }
 }
 
 void bl2_el3_plat_arch_setup(void)
diff --git a/plat/intel/soc/agilex5/include/socfpga_plat_def.h b/plat/intel/soc/agilex5/include/socfpga_plat_def.h
index 1ce1cff1e..60d783dab 100644
--- a/plat/intel/soc/agilex5/include/socfpga_plat_def.h
+++ b/plat/intel/soc/agilex5/include/socfpga_plat_def.h
@@ -14,7 +14,7 @@
 
 /* Platform Setting */
 #define PLATFORM_MODEL						PLAT_SOCFPGA_AGILEX5
-#define BOOT_SOURCE						BOOT_SOURCE_SDMMC
+#define BOOT_SOURCE						BOOT_SOURCE_NAND
 #define MMC_DEVICE_TYPE						1  /* MMC = 0, SD = 1 */
 #define XLAT_TABLES_V2						U(1)
 #define PLAT_PRIMARY_CPU_A55					0x000
diff --git a/plat/intel/soc/common/drivers/combophy/combophy.h b/plat/intel/soc/common/drivers/combophy/combophy.h
index ca571f7b4..1e56b6ba7 100644
--- a/plat/intel/soc/common/drivers/combophy/combophy.h
+++ b/plat/intel/soc/common/drivers/combophy/combophy.h
@@ -12,8 +12,8 @@
 #include "socfpga_handoff.h"
 
 #define PERIPHERAL_SDMMC_MASK		0x60
-#define PERIPHERAL_SDMMC_OFFSET		6
-#define DFI_INTF_MASK			0x1
+#define PERIPHERAL_SDMMC_OFFSET		7
+#define DFI_INTF_MASK			0x0
 
 /* FUNCTION DEFINATION */
 /*
diff --git a/plat/intel/soc/common/drivers/sdmmc/sdmmc.h b/plat/intel/soc/common/drivers/sdmmc/sdmmc.h
index 16c6b04b9..30dff18d2 100644
--- a/plat/intel/soc/common/drivers/sdmmc/sdmmc.h
+++ b/plat/intel/soc/common/drivers/sdmmc/sdmmc.h
@@ -11,7 +11,7 @@
 #include "socfpga_handoff.h"
 
 #define PERIPHERAL_SDMMC_MASK			0x60
-#define PERIPHERAL_SDMMC_OFFSET			6
+#define PERIPHERAL_SDMMC_OFFSET			7
 
 #define DEFAULT_SDMMC_MAX_RETRIES		5
 #define SEND_SDMMC_OP_COND_MAX_RETRIES		100
-- 
2.19.0

